Subject: Re: bug#18541: 24.3; ruler-mode: margins are reset when doing next-buffer/previous-buffer

From: Stefan Monnier <[email-masked]>
Date: Wed, 24 Sep 2014 21:09:59 -0400

>> But indeed, if you set the margin with S-mouse-1 or S-mouse-3 on the
>> header-line, then ruler-mode should arguably try to preserve this
>> setting like you request it.
>   Even if I set margins with S-mouse-1 and S-mouse-3, and then
> type M-x next-buffer RET M-x previous-buffer RET , the margins
> disappear.

Yes, that's what I meant, and this is the actual bug that needs fixing.

>   It could indeed be a nice addition in the future if there's
> some agreement.  I can't think of a case where margin preservation
> could be inappropriate (just a guess: maybe non-interactive sessions?).

There's no reason not to preserve the margin (other than the fact it's
not implemented).  There are questions about *how* to do it, tho.

Mostly, should the margin set by the user be considered as a property of
the buffer (applied wherever the buffer gets displayed), or is it
a property that applies to this buffer but only in this particular window?

E.g. if I have the buffer in window 1 and then display it in window 2,
should window 2 get the same margins as well?  What if window 2 has
a completely different width than window 1?

>   My suggested alternative if one needs to jump around buffers while
> keeping margins enabled in a certain buffer: I noticed that the "window
> configuration registers" preserve margins properly:

> - (... set margins with S-mouse-1 and S-mouse-3 ...)
> - C-x r w a
> - M-x next-buffer RET
> - C-x r j a

Right, that can be a good workaround until ruler-mode does that for you,

        Stefan